function [ir2]=center(ir,pos)
%--------------------------------------------------------------------------
%
%returns ir2 that is is a copy of ir but shifted until the maximus is placed 
%in the position pos:
%
%[ir2]=center(ir,pos)
%
%
%
%   Diego Ivars
%
%--------------------------------------------------------------------------     

                
    

    [m,posit]=max(abs(ir));
    dist=posit-pos;
    
    if dist>0

         ir2=[ir(dist+1:end)',zeros(1,dist)];
        %Impulse response has to be compensated due to variation of the
        %distance. 
        %the delay produced by the soundcard is 2.208ms;
        %fs=48000;
                                            
%%%%%%%%Uncomment for plots of loudspeaker without reflector
                                             
        Rref=343*(2.208*10^(-3)+pos/48000);
        Rprop=343*(2.208*10^(-3)+posit/48000);
        ir2=ir2*Rref/Rprop;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        
    else
        if dist==0
            ir2=ir;

        else

             ir2=[zeros(1,abs(dist)),ir(1:end+dist)'];
            %Impulse response has to be compensated due to variation of the
            %distance. 
            %the delay produced by the soundcard is 2.208ms;
            %fs=48000;
            
%%%%%%%%Uncomment for plots of loudspeaker without reflector

            Rref=343*(2.208*10^(-3)+pos/48000);
            Rprop=343*(2.208*10^(-3)+posit/48000);

            ir2=ir2*Rref/Rprop;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        end
    end
    ir2=ir2';
    
    
    
    
    