function [represmatrix,fs]= radiatdiagram3d(filename,degreestheta,degreesphi,t1,t2,freq,nfft,pos,a)
%--------------------------------------------------------------------------
%
%"radiatdiagram3d" is a program developed to get the frequency response of a 
% loudspeaker in all directions in one specific frequency. It could
% be used to represent the frequency response in 3d plots.
%
%It works with the measurements (files .wmb) obtained with WinMLS. 
%
%
%The way to call it:
%
%[represmatrix]=radiatdiagram3d(filename,degreestheta,degreesphi,t1,t2,freq)
%
%
%- Before and after the filename: ' 
%- degreestheta and degreesphi are the steps advanced in every measurement
%- t1 and t2 mean start and end of the window within the fft is calculated
%- freq is the frequency desired
%
%
%-represmatrix will contain a matrix. The size of the matrix will be 
%(180/degreestheta+1,360/degreesphi+1). 
%represmatrix(1,1) contains the dB(SPL) of theta=0,phi=0 and f=freq
%represmatrix(2,1) contains the dB(SPL) of theta=degreestheta,phi=0 and f=freq
%represmatrix(1,2) contains the dB(SPL) of theta=0,phi=degreesphi and f=freq
% ...
%
%
%
%
%   Diego Ivars
%
%
%--------------------------------------------------------------------------







nfiles = 360/degreesphi;
nfiles2 = 180/degreestheta+1;
filenamestart = [filename,'_'];
%theta is defined from 0 to 180
for ii = 1:nfiles
        filenumb=(ii-1)*degreesphi;
        
        for jj=1:nfiles2
            filenumb2=(jj-1)*degreestheta;
            
            %filename = [filenamestart,int2str(filenumb),'_',int2str(filenumb2),'.wmb'];
        
            filename1 = [filenamestart,int2str(filenumb),'_',int2str(filenumb2),'_Ch1.wmb'];
            filename2 = [filenamestart,int2str(filenumb),'_',int2str(filenumb2),'_Ch2.wmb'];
            filename3 = [filenamestart,int2str(filenumb),'_',int2str(filenumb2),'_Ch3.wmb'];
            filename4 = [filenamestart,int2str(filenumb),'_',int2str(filenumb2),'_Ch4.wmb'];

            if(exist(filename1))
                commandstr = ['[ir,fs] = loadimp(','''',filename1,'''',');'];
                f=1;
            elseif(exist(filename2))
                commandstr = ['[ir,fs] = loadimp(','''',filename2,'''',');'];
                f=2;
            elseif(exist(filename3))
                commandstr = ['[ir,fs] = loadimp(','''',filename3,'''',');'];
                f=3;
            elseif(exist(filename4))
                commandstr = ['[ir,fs] = loadimp(','''',filename4,'''',');'];
                f=4;
            end
                 
            
            
            
           % commandstr = ['[ir,fs] = loadimp(','''',filename,'''',');'];
            eval(commandstr)

            
            ir=center(ir,pos);
             

        
                     
            h1=ir./(20*10^(-6));
            try
                h1=h1(round(t1*fs)+1:round(t2*fs)+1);
            catch
                errordlg('Error. It could be caused by the File name (check SETUP)','Error');
            end

            y=abs(fft(h1,nfft));
            reprod=y(1:nfft/2);
            reprod=reprod(:);
            reprod=reprod';           
            if f==1
                reprod=reprod./a(1,:);
            elseif f==2
                reprod=reprod./a(2,:);
            elseif f==3
                reprod=reprod./a(3,:);
            elseif f==4
                reprod=reprod./a(4,:);
            end
        

            reprod=20*log10(reprod);



            [c,b]=size(reprod);
            if c==1
                reprod=reprod';
            end
             
             
%             h1=ir./(20*10^(-6));
%             h1=h1(t1*fs:t2*fs);
%             tam=size(h1);
%             h2=zeros(fs-tam(1),1);
%             h1=[h1' h2'];
%             y=abs(fft(h1'));
%             reprod=(20*log10(y(1:round(fs/2))));%it keeps the left part of the spectrum
%             %reprod contains the pressure in every frequency (steps of 1Hz)
%             %from 0 to 24000.
%         
%         

            fclose('all'); % Close all open files

            if ii==1 && jj==1
                represmatrix=zeros(nfiles2,(nfiles+1));
            end
            
            represmatrix(jj,ii)=reprod(round(freq*nfft/fs),1);
%             freq
%             frqfft=freq*nfft/fs
%             long=length(reprod)
        end
        
        
end




represmatrix(:,(nfiles+1))=represmatrix(:,1);%if this is not placed,
                                    %the courve is not completely closed.

  